<?php
include_once $_SERVER['DOCUMENT_ROOT'].'/sys/boot.php';

class Votes {

    private $pldir;
    private $HistoryUrl;
    private $HistoryArr;
    private $Viewer;
    private $variants;
    private $results;

    public function __construct($params = array()) {
        $this->pldir = dirname(__FILE__);
        $this->HistoryUrl = $this->pldir . '/votes_history.json';
        $this->HistoryArr = json_decode(file_get_contents($this->HistoryUrl), true);
        $this->Viewer = new Fps_Viewer_Manager;
        $this->variants = file_get_contents($this->pldir . '/template/variants.html');
        $this->results = file_get_contents($this->pldir . '/template/results.html');
    }
    
    
    public function common($params = array()) {
        $out = $this->showQuestion();
        if (!$out)
            $out = $this->showResults();
            
        if (empty($out)) $out = 'Вопросов не имеем';
            
        $out = str_replace('{{ pl_votes }}', $out, $params);
        return $out;
    }
    
    
    public function saveVote($title, $num) {
        if (!file_exists($this->HistoryUrl)) return false;
        
        $data = $this->HistoryArr;
        if (!empty($data) && is_array($data)) {
            foreach ($data as $title_ => $votes) {
                if (html_entity_decode($title) === $title_) {
                    
                    if (count($votes) < 1) return false;
                    $n = 1;
                    foreach ($votes as $vote => $cnt) {
                    
                        
                        if ($n == $num) {
                            $data[$title_][$vote] = $cnt + 1;
                            file_put_contents($this->HistoryUrl, json_encode($data));
                            setcookie(md5($title), date("Y-m-d H:i"), time() + (9999*9999), '/');
                            return true;
                        }
                        $n++;
                    }
                    break;
                }
            }
        }
    }
    
    
    public function showQuestion($params = array()) {
        if (!file_exists($this->HistoryUrl)) return '';
        
        $out = '';
        $output = '';
        $votes = $this->HistoryArr;
        $cnt = count($votes);
        if ($cnt > 0) {
        
            foreach ($votes as $title => $ansvers) {
                if (!empty($_COOKIE[md5($title)])) {
                    unset($votes[$title]);
                }
            }
            $cnt = count($votes);
            if ($cnt < 1) return false;
        
            $rand = rand(0, $cnt - 1);
            $n = 0;
            foreach ($votes as $title => $ansvers) {
                if ($n === $rand) {
                    
                    $num = 0;
                    foreach ($votes[$title] as $vot => $cnt_ansv) {
                        $out[$num]['id'] = $num+1;
                        $out[$num]['variant'] = h($vot);
                        $num++;
                    }
                    
                    $markers = array();
                    $markers['title'] = h($title);
                    $markers['action'] = '{{ plugin_path }}/ajax.php';
                    $markers['votes'] = array_slice($out,0);
                    $output = $this->Viewer->parseTemplate($this->variants, array('pl' => $markers));
                    break;
                }
                $n++;
            }
        }
        
        return $output;
    }
    
    
    public function showResult($title) {
        $title = html_entity_decode($title);
        $output = false;
        if (!file_exists($this->HistoryUrl)) return '';
        $history = $this->HistoryArr;

        if (empty($history) || count($history) < 1 || !array_key_exists($title, $history)) {
            return false;
        }
        

        $history = $history[$title];
        
        if (!empty($history) && count($history) > 0) {
            arsort($history);
            $n = 0;
            $sum = array_sum($history);
            $procent = round($sum / 100, 3);
            $all_votes_cnt = 0;
            foreach ($history as $vote => $cnt_ansv) {
                $votepercents = ($procent) ? ceil($cnt_ansv / $procent) : 0;
                
                $out[$n]['id'] = $n+1;
                $out[$n]['cnt_ans'] = intval($cnt_ansv);
                $out[$n]['persents'] = $votepercents;
                $out[$n]['name'] = $vote;
                $out[$n]['color'] = $this->getColor($vote);
                $n++;
                $all_votes_cnt +=intval($cnt_ansv);
            }
        }
        
        $markers = array();
        $markers['title'] = $title;
        $markers['votes'] = array_slice($out,0);
        $markers['all_votes_cnt'] = $all_votes_cnt;
        $output = $this->Viewer->parseTemplate($this->results, array('pl' => $markers));
        
        return $output;
    }
    
    
    public function showResults($params = array()) {
        $output = '';
        if (!file_exists($this->HistoryUrl)) return '';
        $history = $this->HistoryArr;
        if (empty($history) && count($history) < 1) return $output;

        
        $rand = rand(0, count($history) - 1);
        $keys = array_keys($history);
        $key = $keys[rand(0, count($keys) - 1)];
        
        $output = $this->showResult($key);
        
        
        return $output;
    }
    
    
    private function getColor($k) {
        $color = substr(md5($k), 0, 6);
        $color = str_replace ('d','0',$color);
        $color = str_replace ('e','1',$color);
        $color = str_replace ('f','2',$color);
        return $color;
    }
    
}
?>